## libfann 2.1.0~beta~dfsg

=== benchmarks/Makefile ===
# The jneural library (http://voltar-confed.org/jneural/) and lwneuralnet library (http://sourceforge.net/projects/lwneuralnet/) needs to be installed in order to run the benchmarks

GCC = gcc
G++ = g++

TARGETS = quality quality_fixed performance performance_fixed shuffle parity two-spirals

CFLAGS = -O3 -finline-functions -funroll-loops -Werror

LFLAGS = -lm

JNEURALDIR = ../../libraries/jneural/

LWNNDIR = ../../libraries/lwneuralnet-0.8/source/

all: $(TARGETS)

quality: quality.cc
	$(G++) $(CFLAGS) $(LFLAGS) -I$(JNEURALDIR)include/ -L$(JNEURALDIR) -I$(LWNNDIR) -L$(LWNNDIR) $< -o $@ -lfloatfann -llwneuralnet -ljneural -lfl

quality_fixed: quality_fixed.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@ -lfixedfann

quality_fixed_debug: quality_fixed.c
	$(GCC) -ggdb -lm -DDEBUG -Wall -ansi -I../src/ -I../src/include/ ../src/fixedfann.c $< -o $@

performance: performance.cc
	$(G++) $(CFLAGS) $(LFLAGS) -I$(JNEURALDIR)include/ -L$(JNEURALDIR) -I$(LWNNDIR) -L$(LWNNDIR) $< -o $@ -lfloatfann -llwneuralnet -ljneural -lfl

performance_fixed: performance.cc
	$(G++) $(CFLAGS) $(LFLAGS) -DFIXEDFANN $< -o $@ -lfixedfann

shuffle: shuffle.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@ -lfloatfann

two-spirals: two-spirals.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@

parity: parity.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@

clean: 
	rm -rf -- $(TARGETS) *~

distclean: clean
	rm -rf *.ps *.out *.net *fixed_test* *fixed_train*

=== examples/Makefile ===
# This makefile is on purpose not made with configure, to show how to use the library
# The make file requires that the fann library is installed (see ../README)

GCC=gcc

TARGETS = xor_train xor_test xor_test_fixed simple_train steepness_train simple_test robot mushroom cascade_train scaling_test scaling_train
DEBUG_TARGETS = xor_train_debug xor_test_debug xor_test_fixed_debug cascade_train_debug

all: $(TARGETS)

%: %.c Makefile
	$(GCC) -O3 $< -o $@ -lm -lfann

%_fixed: %.c Makefile
	$(GCC) -O3 -DFIXEDFANN $< -o $@ -lm -lfixedfann

clean:
	rm -f $(TARGETS) $(DEBUG_TARGETS) xor_fixed.data *.net *~ *.obj *.exe *.tds noscale.txt withscale.txt scale_test_results.txt

runtest: $(TARGETS)
	@echo
	@echo Training network
	./xor_train

	@echo
	@echo Testing network with floats
	./xor_test

	@echo
	@echo Testing network with fixed points
	./xor_test_fixed

#below this line is only for debugging the fann library

rundebugtest: $(DEBUG_TARGETS)
	@echo
	@echo Training network
	./xor_train_debug

	@echo
	@echo Testing network with floats
	./xor_test_debug

	@echo
	@echo Testing network with fixed points
	./xor_test_fixed_debug

runcompliancetest: $(DEBUG_TARGETS)
	./xor_train_debug

	@echo
	@echo Testing network with floats
	@cp xor_float.net xor_float_new.net
	@cp xor_float_backup.net xor_float.net
	@echo RUN
	@./xor_test_debug | grep XOR
	@echo CAT
	@cat xor_float_backup.out

#used to compare result when scale used and not used
runscaletest: scaling_train scaling_test
	echo Without scaling > noscale.txt
	./scaling_train >> noscale.txt
	./scaling_test >> noscale.txt
	echo With scaling > withscale.txt
	./scaling_train scale >> withscale.txt
	./scaling_test scale >> withscale.txt
	pr -m -t -T -w 150 noscale.txt withscale.txt > scale_test_results.txt
	@echo See scale_test_results.txt for results of scaling test

#compiletest is used to test whether the library will compile easily in other compilers
compiletest:
	gcc -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_train.c -o xor_train -lm 
	gcc -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -DFIXEDFANN -I../src/ -I../src/include/ ../src/fixedfann.c xor_test.c -o xor_test -lm 
	g++ -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_train.c -o xor_train -lm 

quickcompiletest:
	gcc -O -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c ../examples/xor_train.c -o ../examples/xor_train -lm 

debug: $(DEBUG_TARGETS)

%_debug: %.c Makefile ../src/*c ../src/include/*h
	$(GCC) -ggdb -DDEBUG -Wall -ansi -I../src/ -I../src/include/ ../src/floatfann.c $< -o $@ -lm 

%_fixed_debug: %.c Makefile ../src/*c ../src/include/*h
	$(GCC) -ggdb -DDEBUG -Wall -ansi -DFIXEDFANN -I../src/ -I../src/include/ ../src/fixedfann.c $< -o $@ -lm

rundebug: $(DEBUG_TARGETS)
	@echo
	@echo Training network
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_train_debug

	@echo
	@echo Testing network with floats
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_test_debug

	@echo
	@echo Testing network with fixed points
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_test_fixed_debug

=== python/Makefile ===
# This makefile was written to compile a distribution of pyfann for
# GNU platforms (cygwin included.)

ROOT=/
PYTHON=python

SOURCES = pyfann/*.i pyfann/*.h
all: build-stamp

linux:
	@(cd pyfann && make)

clean:
	@(cd pyfann && make clean)
	@rm -fr dist build setup.pyc
	@rm -fr examples/{nets,pyfann/}
	@rm -f build-stamp
	
msvc:
	@(cd pyfann && make -f makefile.msvc)

build:
build-stamp: ../src/doublefann.o $(SOURCES)
	@$(PYTHON) setup.py build
	@touch build-stamp

install: build-stamp
	@$(PYTHON) setup.py install --root $(ROOT)

../src/doublefann.o: ../Makefile
	@(cd .. && make )

../Makefile:
	@(cd .. && ./configure)

copy: build-stamp
	@- [ -d examples/nets ] || mkdir examples/nets
	@cp build/lib.*/pyfann/ -a examples
    
test: copy
	@cd examples && \
		$(PYTHON) simple_train.py && \
		$(PYTHON) mushroom.py &&\
		$(PYTHON) cascade_train.py
.PHONY: test install msvc clean linux all

=== python/pyfann/Makefile ===
# This makefile was written to compile a distribution of pyfann for
# GNU platforms (cygwin included.)

TARGETS = _libfann.so

PYTHON=python2.3
FANN_DIR="../.."
LIBS=-L. -L/usr/local/lib -L/usr/bin -l$(PYTHON) $(FANN_DIR)/src/fann*.o

all: $(TARGETS)
	
_%.so: pyfann_wrap.o fann_helper.o
	gcc $(LIBS) -fPIC -shared -dll $^ -o $@

%.o: %.c 
	gcc -fPIC -shared -c $< -I/usr/include/$(PYTHON)/ -I$(FANN_DIR)/src/include/

pyfann_wrap.cpp: pyfann.i 
	swig -c++ -python $<

clean:
	rm -f $(TARGETS) *_wrap.* *.py{c,o} *.so libfann.*

=== debian/changelog ===
libfann (2.1.0~beta~dfsg-8ubuntu1) raring; urgency=low

  * Add simple autopkgtest to package. 

 -- Vibhav Pant <vibhav@ubuntu.com>  Fri, 01 Mar 2013 11:53:17 +0100

libfann (2.1.0~beta~dfsg-8) unstable; urgency=low

  * debian/control:
    - Build-Depend on swig (>= 2.0.4-2) instead of swig2.0; the former has now
      taken over the /usr/bin/swig symlink. Closes: #634430

 -- Christian Kastner <debian@kvr.at>  Thu, 11 Aug 2011 00:46:29 +0200

libfann (2.1.0~beta~dfsg-7) unstable; urgency=low

  * debian/rules:
    - Convert debian/rules to regular syntax. By providing custom build-arch
      and build-indep targets, we can avoid a FTBFS. Closes: #630100
    - Honor compiler flags provided by dpkg-buildflags

 -- Christian Kastner <debian@kvr.at>  Sat, 11 Jun 2011 03:29:01 +0200

libfann (2.1.0~beta~dfsg-6) unstable; urgency=low

  * debian/rules
    debian/libfann-doc
    debian/libfann-dev
    debian/README-libfann2-examples
    debian/README-python-examples-data
    debian/example-paths.sed
    debian/Makefile.examples:
    - Moved the examples and related data to the from the libfann-dev and
      python-pyfann to the libfann-doc package. lintian was rightfully
      complaining about them being in arch: any package.
  * debian/control:
    - Now that the examples have moved, it is sufficient for libfann-dev to
      only Suggest libfann-doc
    - libfann-doc now Recommends libfann-dev, python-pyfann (so the examples
      can be used)
    - python-pyfann Suggests libfann-doc
    - Updated package descriptions
  *  debian/example-paths.sed:
    - Simplified, by using extended regular expressions
  * debian/patches added:
    - 0006-Include-fann_cpp.h-in-dev-package.patch
      This was deliberately omitted in the past due to some ambiguity regarding
      its support status. Upstream homepage says it's OK though, so we'll just
      include it. Closes: #629827

 -- Christian Kastner <debian@kvr.at>  Fri, 10 Jun 2011 02:58:53 +0200

libfann (2.1.0~beta~dfsg-5) unstable; urgency=low

  [ Christian Kastner ]
  * debian/control:
    - Build-Depend on swig2.0 (>= 2.0.3), the earliest swig2.0 version
      providing /usr/bin/swig

  [ Yaroslav Halchenko ]
  * debian/control:
    - Added DM-Upload-Allowed

 -- Christian Kastner <debian@kvr.at>  Wed, 01 Jun 2011 01:13:31 +0200

libfann (2.1.0~beta~dfsg-4) unstable; urgency=low

  * debian/control:
    - Build-Depend on swig2.0 instead of swig; fixes FTBFS with gcc-4.6.
      Closes: #625123, LP: #770839

 -- Christian Kastner <debian@kvr.at>  Mon, 09 May 2011 00:38:53 +0200

libfann (2.1.0~beta~dfsg-3) unstable; urgency=low

  * debian/control:
    - Bumped Standards-Version to 3.9.2 (changes required)
    - Updated Homepage (new location)
  * debian/rules:
    - In libtool *.la files, set dependency_libs to null string as required by
      Policy section 10.2. Closes: #621572
  * debian/copyright:
    - Updated DEP5 format to r173
    - Updated DEP5 keyword for BSD-3-clause license
   * debian/watch:
    - uversionmangle release qualifier (here: beta) instead of dversionmangle
  * debian/patches added:
    - 0005-Correct-a-typo-in-a-size-comparison
      Fixes a typo in the python wrapper. LP: #712290

 -- Christian Kastner <debian@kvr.at>  Sat, 02 Apr 2011 20:06:47 +0200

libfann (2.1.0~beta~dfsg-2) unstable; urgency=low

  * debian/control:
    - Bump Standards-Version to 3.9.0 (no changes needed)
    - Description fixes
    - Added libfann-dbg and python-pyfann-dbg packages
    - Changed Section of source package to libs
  * debian/libfann-dev.dirs:
    - Removed because redundant to dh_install
  * debian/rules:
    - Don't handle nostrip, dh_strip handles it for us
    - Build libfann-dbg and python-pyfann-dbg with the help of dh_strip
  * debian/libfann2.symbols:
    - Initial creation
  * debian/copyright:
    - Convert to DEP5 format
    - Relicense patches to BSD
  * debian/patches:
    - Added 0004-Portable-handling-for-va_list
      Makes the use of va_list portable, fixing a FTBFS on alpha/armel/sh4.
      Closes: #588887
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Christian Kastner <debian@kvr.at>  Wed, 14 Jul 2010 22:12:27 +0200

libfann (2.1.0~beta~dfsg-1) unstable; urgency=low

  * New Maintainer. Closes: #583645
  * New upstream version 2.1.0beta
    - Closes: #366146
    - Repackaged upstream version to remove non-DFSG-compliant files
  * debian/compat:
    - Bumped debhelper compatibility to 7
  * debian/control:
    - Renamed source package from libfann2 to libfann
    - Updated package descriptions
    - Updated to Standards-Version 3.8.4
    - Build-Depend on debhelper (> 7.0.50~) and add ${misc:Depends}
    - Added Build-Depends on python-all-dev and python-support for the python
      extension
    - Added new package libfann-doc for the API HTML documentation, and make
      other package Recommend or Suggest it
    - Added Build-Depends on naturaldocs for API HTML documentation
    - Removed Build-Depends on docbook-utils (no longer supported by upstream)
    - Added Build-Depends on autotools-dev to update config.{sub,guess}
    - Added proper Conflicts: and Replaces: for older versions
    - Added Homepage field
    - Added VCS-* fields
  * debian/source/format:
    - Convert to format 3.0 (quilt)
  * debian/rules:
    - Convert to dh syntax
    - Build python extensions for all available python versions
    - Generate API HTML documentation using naturaldocs
    - Update config.{sub,guess} during build
  * debian/copyright:
    - Updated
  * debian/watch:
    - Created watch file
  * libfann2-py:
    - Rename package to Python Policy-conform python-pyfann
    - Removed debhelper helper files no longer needed because of python-support
    - Modify example paths and include instructions on how to run them
  * libfann-doc:
    - New package
    - Add doc-base entry for documentation. Closes: #297951
  * libfann2-dev:
    - Renamed to libfann-dev


=== debian/control ===
Source: libfann
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christian Kastner <debian@kvr.at>
DM-Upload-Allowed: yes
Build-Depends:
    debhelper (>= 7.0.50~),
    autotools-dev,
    python-all-dev,
    python-support (>= 0.90),
    swig (>= 2.0.4-2),
    naturaldocs
XS-Testsuite: autopkgtest
Standards-Version: 3.9.2
Homepage: http://leenissen.dk/fann/wp/
Vcs-Git: git://scm.kvr.at/git/pkg-libfann.git
Vcs-Browser: http://scm.kvr.at/git/?p=pkg-libfann.git;a=summary

Package: libfann2
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Suggests:
    libfann-dev (= ${binary:Version}),
    libfann-doc (= ${binary:Version})
Conflicts:
    libfann1
Replaces:
    libfann1
Description: Fast Artificial Neural Network Library
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. A Python binding is available, and bindings for
 PHP, C++, .NET, Delphi, Octave, Ruby, Pure Data and Mathematica
 can be downloaded from FANN's homepage.
 .
 This package contains the shared libraries.

Package: libfann-dev
Section: libdevel
Architecture: any
Depends:
    ${misc:Depends},
    libfann2 (= ${binary:Version})
Suggests:
    libfann-doc (= ${binary:Version})
Conflicts:
    libfann1-dev
Replaces:
    libfann1-dev
Description: Development libraries and header files for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. A Python binding is available, and bindings for
 PHP, C++, .NET, Delphi, Octave, Ruby, Pure Data and Mathematica
 can be downloaded from FANN's homepage.
 .
 This package contains the header files and static libraries which are
 needed for developing libfann applications.

Package: libfann-dbg
Priority: extra
Section: debug
Architecture: any
Depends:
    ${misc:Depends},
    libfann2 (= ${binary:Version})
Description: Debugging symbols for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. A Python binding is available, and bindings for
 PHP, C++, .NET, Delphi, Octave, Ruby, Pure Data and Mathematica
 can be downloaded from FANN's homepage.
 .
 This package contains the debugging symbols for the libfann library.

Package: python-pyfann
Section: python
Architecture: any
Depends:
    ${python:Depends},
    ${shlibs:Depends},
    ${misc:Depends},
    libfann2 (= ${binary:Version})
Suggests:
    libfann-dev (= ${binary:Version}),
    libfann-doc (= ${binary:Version})
Description: Python bindings for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. A Python binding is available, and bindings for
 PHP, C++, .NET, Delphi, Octave, Ruby, Pure Data and Mathematica
 can be downloaded from FANN's homepage.
 .
 This package contains the Python wrapper for FANN.

Package: python-pyfann-dbg
Priority: extra
Section: debug
Architecture: any
Depends:
    ${misc:Depends},
    python-pyfann (= ${binary:Version})
Description: Debugging symbols for FANN Python wrapper
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. A Python binding is available, and bindings for
 PHP, C++, .NET, Delphi, Octave, Ruby, Pure Data and Mathematica
 can be downloaded from FANN's homepage.
 .
 This package contains the debugging symbols for the FANN Python wrapper.

Package: libfann-doc
Section: doc
Architecture: all
Depends:
    ${misc:Depends}
Recommends:
    libfann-dev (= ${binary:Version}),
    python-pyfann (= ${binary:Version})
Description: API documentation for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. A Python binding is available, and bindings for
 PHP, C++, .NET, Delphi, Octave, Ruby, Pure Data and Mathematica
 can be downloaded from FANN's homepage.
 .
 This package contains the API documentation in HTML form and some
 introductory material in text form. It also contains examples for
 the library and the Python wrapper.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Standard compiler flags
CFLAGS += -Wall

PYVERS = $(shell pyversions -r -v)


binary: binary-arch binary-indep
build: build-arch build-indep
install: install-arch install-indep


configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autotools-dev_updateconfig
	dh_auto_configure


build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	# Perform regular build process
	dh_auto_build -a
	
	# Build python extensions in python/
	cd python; \
	for py in $(PYVERS); do \
		python$$py setup.py build; \
	done


build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	
	# Build documentation
	mkdir -p doc/html doc/proj
	naturaldocs -i src/include -o HTML doc/html -p doc/proj


install-arch:
	dh_testdir
	dh_testroot
	dh_prep -a
	dh_installdirs -a
	dh_auto_install -a
	
	# Clear .la dependency_libs as required by Policy 10.2
	sed -i -e "s/dependency_libs='.*'/dependency_libs=''/" \
		debian/tmp/usr/lib/*.la
	
	# Install python extensions from python/, so dh_pysupport can pick them up
	cd python; \
	for py in $(PYVERS); do \
		python$$py setup.py install -f --root $(CURDIR)/debian/python-pyfann \
			--install-layout=deb; \
	done
	
	dh_install -a


install-indep:
	dh_testdir
	dh_testroot
	dh_prep -i
	dh_installdirs -i
	dh_install -i


binary-arch: build-arch install-arch
	dh_installdocs -a
	dh_installchangelogs -a
	dh_pysupport -a
	
	# Point doc of -dbg packages to their regular counterparts
	rm -rf debian/libfann-dbg/usr/share/doc/libfann-dbg
	rm -rf debian/python-pyfann-dbg/usr/share/doc/python-pyfann-dbg
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	
	# Can't use --dbg-package because we have multiple debug packages
	dh_strip -k -a
	mv debian/libfann2/usr/lib/debug debian/libfann-dbg/usr/lib
	mv debian/python-pyfann/usr/lib/debug debian/python-pyfann-dbg/usr/lib
	cd debian/python-pyfann-dbg/usr/lib/debug/usr/lib && mv pyshared pymodules
	
	dh_makeshlibs -a
	dh_shlibdeps -a
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a


binary-indep: build-indep install-indep
	dh_installdocs -i 
	dh_installchangelogs -i
	dh_installexamples -i
	
	# Copy Python examples to a subdir in examples/
	cp -r python/examples \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/python
	
	# Modify dataset paths in examples to point to libfann-doc datasets. This
	# was not implemented as a patch to upstream to preserve the ability to
	# run upstream's own tests within the source dir.
	sed -i -r -f debian/example-paths.sed \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/*.c \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/python/*.py
	
	# Add Makefile & compile/run instructions for the examples
	cp debian/Makefile.examples \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/Makefile
	cp debian/README-libfann2-examples \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/README
	
	# Don't compress example files and datasets; documentation .js
	dh_compress -i -Xexamples -Xjavascript
	
	dh_fixperms -i
	# Remove unnecessary executable bits from training data sets
	chmod 644 debian/libfann-doc/usr/share/doc/libfann-doc/examples/datasets/*
	
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


clean:
	dh_testdir
	dh_autotools-dev_restoreconfig
	
	# Perform regular clean process
	dh_auto_clean
	dh_clean
	
	# Clean up Python stuff
	rm -rf python/build python/pyfann/*.cxx
	
	# Remove output generated by naturaldocs
	rm -rf doc/proj doc/html
	
	# Finalize
	rm -f configure-stamp build-arch-stamp build-indep-stamp


.PHONY: binary configure build install clean
.PHONY: binary-arch binary-indep build-arch build-indep install-arch install-indep

=== debian/tests/control ===
Tests: build
Depends: libfann-dev, build-essential

=== debian/watch ===
version=3

opts=\
uversionmangle=s/([.0-9]+)(\D+)/$1~$2/,\
dversionmangle=s/~dfsg// \
http://sf.net/fann/fann-(\d.*).zip

## libfann 2.1.0~beta+dfsg

=== debian/changelog ===
libfann (2.1.0~beta+dfsg-1) unstable; urgency=medium

  * Use +dfsg modifier in version instead of the semantically incorrect ~dfsg.
    This is just a rename, there were no actual changes to the upstream source
  * Migrate git repo to Debian-Science at git.debian.org
  * debian/control:
    - Bump Standards-Version to 3.9.6 (no changes needed)
    - Update Vcs-* URLs to point to new location
  * debian/rules:
    - Add override for dh_install and use --fail-missing
    - Drop the custom code for running Python tests and use Pybuild for that
      stage, too
  * debian/tests:
    - python-build
      + Allow selection of Python interpreter to use

 -- Christian Kastner <debian@kvr.at>  Fri, 19 Sep 2014 16:17:53 +0200

libfann (2.1.0~beta~dfsg-10) unstable; urgency=low

  * debian/control:
    - Add Build-Depends for dh-autoreconf
    - Drop Build-Depends for autotools-dev
  * debian/rules:
    - Switch from autotools-dev to dh-autoreconf. Closes: #744606
    - Call dh_auto_build for python-pyfann twice, because distutils runs
      build_py before build_ext, but build_py relies on output from build_ext
      (from SWIG), and this order cannot be changed. This is a known issue, see
      http://bugs.python.org/issue7562
    - Run "build" autopkgtest after build
    - Run "python-build" autopkgtest after build, for all supported Python
      versions
    - Fix setting of DEB_CFLAGS_MAINT_APPEND
  * debian/tests:
    - build
      + Rewrite to make use of $ADTTMP
    - python-build
      + Create (runs one of the example scripts)
  * debian/copyright:
    - Updates for my changes to debian/test/*
  * debian/patches (refreshed):
    - 0002-Link-against-libm
      Properly extend autotools setup for libm instead of using a dirty hack
    - 0006-Include-fann_cpp.h-in-dev-package
      Don't pointlessly modify Makefile.in

 -- Christian Kastner <debian@kvr.at>  Thu, 24 Apr 2014 00:51:29 +0200

libfann (2.1.0~beta~dfsg-9) unstable; urgency=low

  * debian/rules:
    - Convert to dh syntax
    - Convert Python build helper from deprecated python-support to dh_python2
    - In addition to the default "makefile" build system, use the "pybuild"
      build system for building the Python extension. This way we no longer
      have to iterate over the supported Python versions.
    - Fix FTBFS by cleaning SWIG-generated file. Closes: #643187
    - Use DEB_CFLAGS_MAINT_APPEND instead of CFLAGS
  * debian/control:
    - Bump Standards-Version to 3.9.5 (no changes needed)
    - Bump debhelper Build-Depends to (>= 9)
    - Add Multi-Arch: same to libfann2, libfann-dev, libfann-dbg
    - Add Build-Depends for dh-python
    - Add X-Python-Version with >= 2.6, thereby implicitly dropping support for
      Python 2.5 (it used to be supported in the now removed debian/pyversions).
    - Add XS-Testsuite for autopkgtest
    - Drop Build-Depends for python-support
    - Move naturaldocs to Build-Depends-Indep
    - Remove obsolete DM-Upload-Allowed field
  * debian/compat:
    - Bump debhelper compatibility level to 9
  * debian/libfann-dev.install
    debian/libfann2.install:
    - Change paths from usr/lib/ to usr/lib/*/ (for mutli-arch triplets)
  * debian/copyright:
    - Update to machine-readable format v1.0
    - Update Source: link
    - Add comment to debian/copyright explaining how DFSG-cleaning was
      performed
  * debian/test/*
    - Add autpkgtest for successful build & run against libfann. Taken from
      Ubuntu. Thanks, Vibhav Pant. Closes: #702423
  * debian/patches (added):
    - 0007-Do-not-call-swig-unconditionally
      The SWIG interface was being built on every invocation of setup.py,
      even during a mere install
  * debian/source/lintian-overrides:
    - Added override for debian-watch-may-check-gpg-signature
  * debian/watch:
    - Don't try to pattern-match beta, just match beta
    - Upstream release filename has changed
  * debian/gbp.conf
    - Created (package is based on dfsg branch, not upstream)

 -- Christian Kastner <debian@kvr.at>  Fri, 28 Mar 2014 21:33:42 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,27 @@
 Source: libfann
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christian Kastner <debian@kvr.at>
-DM-Upload-Allowed: yes
+Maintainer: Christian Kastner <debian@kvr.at>
 Build-Depends:
-    debhelper (>= 7.0.50~),
-    autotools-dev,
+    debhelper (>= 9),
+    dh-autoreconf,
     python-all-dev,
-    python-support (>= 0.90),
-    swig (>= 2.0.4-2),
+    dh-python,
+    swig (>= 2.0.4-2)
+Build-Depends-Indep:
     naturaldocs
+Standards-Version: 3.9.6
+X-Python-Version: >= 2.6
 XS-Testsuite: autopkgtest
-Standards-Version: 3.9.2
 Homepage: http://leenissen.dk/fann/wp/
-Vcs-Git: git://scm.kvr.at/git/pkg-libfann.git
-Vcs-Browser: http://scm.kvr.at/git/?p=pkg-libfann.git;a=summary
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/libfann.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libfann.git
 
 Package: libfann2
 Architecture: any
+Multi-Arch: same
+Pre-Depends:
+    ${misc:Pre-Depends}
 Depends:
     ${shlibs:Depends},
     ${misc:Depends}
@@ -45,6 +48,7 @@
 Package: libfann-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends:
     ${misc:Depends},
     libfann2 (= ${binary:Version})
@@ -72,6 +76,7 @@
 Priority: extra
 Section: debug
 Architecture: any
+Multi-Arch: same
 Depends:
     ${misc:Depends},
     libfann2 (= ${binary:Version})

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These get included in the build flags by debhelper
export DEB_CFLAGS_MAINT_APPEND = -Wall

# For pybuild
export PYBUILD_NAME=pyfann


%:
	dh $@ --with autoreconf,python2


override_dh_autoreconf:
	dh_autoreconf --as-needed


override_dh_auto_configure-arch:
	dh_auto_configure


override_dh_auto_configure-indep:
	# Nothing to do


override_dh_auto_build-arch:
	# Library
	dh_auto_build
	# Python extension. Must be run twice, because distutils runs build_py
	# before build_ext, but build_py relies on output from build_ext (from
	# SWIG), and the order cannot be changed. This is a known issue, see
	# http://bugs.python.org/issue7562
	dh_auto_build --buildsystem=pybuild --sourcedirectory=python
	dh_auto_build --buildsystem=pybuild --sourcedirectory=python


override_dh_auto_build-indep:
	# Build just the documentation
	mkdir -p doc/html doc/proj
	naturaldocs -i src/include -o HTML doc/html -p doc/proj


override_dh_auto_test-arch:
	# Simulate partial autopkgtest run by providing an ADTTMP and setting
	# CPATH/LIBRARY_PATH/LD_LIBRARY_PATH for the build test, and
	# LD_LIBRARY_PATH/PYTHONPATH for the Python test.
	#
	# We don't create a separate $ADTTMP for all of the tests because it
	# is not possible -- we only have one Pybuild command, but it may
	# perform tests for more than one version, so we just manually clean it
	# before each test using PYBUILD_BEFORE_TEST.
	testrundir=$$(mktemp -d) ;\
		ADTTMP=$$testrundir \
		CPATH=$(CURDIR)/src/include \
		LIBRARY_PATH=$(CURDIR)/src/.libs \
		LD_LIBRARY_PATH=$(CURDIR)/src/.libs \
	/bin/sh $(CURDIR)/debian/tests/build ;\
	[ $$? -eq 0 ] || exit 1 ;\
	\
		ADTTMP=$$testrundir \
		LD_LIBRARY_PATH=$(CURDIR)/src/.libs \
		PYBUILD_SYSTEM=custom \
		PYBUILD_BEFORE_TEST="cd $$ADTTMP && rm -rf *" \
		PYBUILD_TEST_ARGS="PYINTERPRETER={interpreter} /bin/sh $(CURDIR)/debian/tests/python-build" ;\
	du_auto_test --buildsystem=pybuild ;\
	rm -rf "$$testrundir"


override_dh_auto_test-indep:
	# Nothing to do


override_dh_auto_install-arch:
	# Library
	dh_auto_install
	
	# Clear .la dependency_libs as required by Policy 10.2
	sed -i -e "s/dependency_libs='.*'/dependency_libs=''/" \
		debian/tmp/usr/lib/*/*.la
	
	# Python extension
	dh_auto_install --buildsystem=pybuild --sourcedirectory=python


override_dh_auto_install-indep:
	# Nothing to do


override_dh_install:
	dh_install --fail-missing
	

override_dh_installexamples-indep:
	dh_installexamples -i
	
	# Copy Python examples to a subdir in examples/
	cp -r python/examples \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/python
	
	# Modify dataset paths in examples to point to libfann-doc datasets. This
	# was not implemented as a patch to upstream to preserve the ability to
	# run upstream's own tests within the source dir.
	sed -i -r -f debian/example-paths.sed \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/*.c \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/python/*.py
	
	# Add Makefile & compile/run instructions for the examples
	cp debian/Makefile.examples \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/Makefile
	cp debian/README-libfann2-examples \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/README
	

override_dh_fixperms-indep:
	dh_fixperms -i
	# Remove unnecessary executable bits from training data sets
	chmod 644 debian/libfann-doc/usr/share/doc/libfann-doc/examples/datasets/*


override_dh_link:
	# dh_link does not remove pre-existing destination dirs, only files
	rm -rf debian/libfann-dbg/usr/share/doc/libfann-dbg
	rm -rf debian/python-pyfann-dbg/usr/share/doc/python-pyfann-dbg
	dh_link


override_dh_compress:
	dh_compress -Xexamples -Xjavascript


override_dh_strip:
	# Can't use --dbg-package because we have multiple debug packages
	dh_strip -k -a
	mv debian/libfann2/usr/lib/debug debian/libfann-dbg/usr/lib
	mv debian/python-pyfann/usr/lib/debug debian/python-pyfann-dbg/usr/lib


override_dh_auto_clean:
	# Perform regular clean process
	dh_auto_clean
	
	# Python clean
	dh_auto_clean --buildsystem=pybuild --sourcedirectory=python
	
	# SWIG stuff
	rm -rf python/pyfann/pyfann_wrap.cpp python/pyfann/libfann.py
	
	# Remove output generated by naturaldocs
	rm -rf doc/proj doc/html

=== debian/tests/control ===
Tests: build
Depends: libfann-dev, build-essential

Tests: python-build
Depends: python-pyfann

=== debian/watch ===
version=3

opts=\
uversionmangle=s/([.0-9]+)beta/$1~beta/,\
dversionmangle=s/~dfsg// \
http://sf.net/fann/FANN-(\d.*)-Source.tar.gz

## libfann 2.2.0%2Bds

=== debian/control ===
Source: libfann
Section: libs
Priority: optional
Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends:
    debhelper-compat (= 13),
    cmake,
Build-Depends-Indep:
    naturaldocs
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://leenissen.dk/fann/wp/
Vcs-Git: https://salsa.debian.org/science-team/libfann.git
Vcs-Browser: https://salsa.debian.org/science-team/libfann

Package: libfann2
Architecture: any
Multi-Arch: same
Pre-Depends:
    ${misc:Pre-Depends}
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Suggests:
    libfann-dev (= ${binary:Version}),
    libfann-doc (= ${binary:Version})
Conflicts:
    libfann1
Replaces:
    libfann1
Description: Fast Artificial Neural Network Library
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast.
 .
 This package contains the shared libraries.

Package: libfann-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    ${misc:Depends},
    libfann2 (= ${binary:Version})
Suggests:
    libfann-doc (= ${binary:Version})
Conflicts:
    libfann1-dev
Replaces:
    libfann1-dev
Description: Development libraries and header files for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast.
 .
 This package contains the header files and static libraries which are
 needed for developing libfann applications.

Package: libfann-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
    ${misc:Depends}
Recommends:
    libfann-dev (= ${binary:Version}),
Description: API documentation for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast.
 .
 This package contains the API documentation in HTML form and some
 introductory material in text form.
